; Character Data Loader (can only load 8 characters at a time)



; Requirements:

; HL Register set to the start of the character data.



; Character Data Format:        

; DB 31d ; Character Bytes ((No. of Chars * 32) - 1) Values 31-255

; DB 00h ; Low byte of the Video Address

; DB 40h ; High byte of the Video Address

; DB 20h ; Byte 0 of the first character

; ...

; DB 00h ; Byte 31 of the first character



LDCHR:  LD B, (HL)      ; Number of character bytes (255 max)

        INC HL

        LD A, (HL)

        OUT (0BFh), A   ; Low byte of the VRAM address

        INC HL

        LD A, (HL)

        OUT (0BFh), A   ; High byte of the VRAM address

        INC HL          ; Now points to byte 0 of the first character

        LD C, 0BEh

        OTIR            ; And away we go...

        RET

