; PALETTE LOADER (REVISION 1)

;  0: Loads Character or Spirte Palettes

;     Want to include the ability to load both palettes with

;     the same data in the next revision

;  1: Now can load both palettes with the same colors, just use some other

;     value other than 00h or FFh in the type byte.



; REQUIREMENTS:

; (HL) To Point To The Palette To Load



; CHANGES:

; ALL registers

; VRAM C000h-C01Fh



; DATA FORMAT:

; DB 00h ; Palette Type (00h = Character Palette, FFh = Sprite Palette,

;                        Anything else = Both Palettes)

; DB 00000000b ; Entry 00h (Black)

; DB 00000011b ; Entry 01h (Red)

; DB 00001100b ; Entry 02h (Green)

; DB 00110000b ; Entry 03h (Blue)

; DB 00000010b ; Entry 04h (Medium Red)

; DB 00001000b ; Entry 05h (Medium Green)

; DB 00100000b ; Entry 06h (Medium Blue)

; DB 00000001b ; Entry 07h (Dark Red)

; DB 00000100b ; Entry 08h (Dark Green)

; DB 00010000b ; Entry 09h (Dark Blue)

; DB 00101010b ; Entry 0Ah (Light Gray)

; DB 00010101b ; Entry 0Bh (Dark Gray)

; DB 00111100b ; Entry 0Ch (Cyan)

; DB 00110011b ; Entry 0Dh (Magenta)

; DB 00001111b ; Entry 0Eh (Yellow)

; DB 00111111b ; Entry 0Fh (White)



LDPAL:  LD A, (HL)      ; Point A to the first byte of the palette

        AND A           ; Check for 00h

        JP Z, CHPAL

        CPL             ; FFh will turn into 00h

        AND A           ; Check to see if it was FFh

        JP Z, SPPAL

        LD DE, HL       ; Save HL for CHPAL to use

        CALL SPPAL      ; Call SPPAL cause I can use CHPAL's RET

        LD HL, DE       ; Get HL back and run right into CHPAL

CHPAL:  OUT (0BFh), 00h ; Output to the Character Palette

        OUT (0BFh), 0C0h

        INC HL          ; Now points to Palette Entry 0

        LD BC, 0FBEh    ; 16 Entries/Port 0BEh

        OTIR            ; Dump all 16 to the VRAM

        RET

SPPAL:  OUT (0BFh), 10h ; Output to the Sprite Palette

        OUT (0BFh), 0C0h

        INC HL          ; Now points to Palette Entry 0

        LD BC, 0FBEh    ; 16 Entries/Port 0BEh

        OTIR            ; Dump all 16 to the VRAM

        RET

